Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/Splitting/NeumaierSum.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/Splitting/NeumaierSum.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/Splitting/NeumaierSum.cs	(revision 16892)
@@ -0,0 +1,63 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Runtime.CompilerServices;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  /// <summary>
+  /// Helper class for incremental split calculation.
+  /// Used while moving a potential Splitter along the ordered training Instances
+  /// </summary>
+  internal class NeumaierSum {
+    #region state
+    private double sum;
+    private double correction;
+    #endregion
+
+    #region Constructors
+    public NeumaierSum(double startvalue) {
+      sum = startvalue;
+      correction = 0;
+    }
+    #endregion
+
+    [MethodImpl(MethodImplOptions.NoOptimization)]
+    public void Add(double value) {
+      var t = sum + value;
+      var absSum = sum > 0 ? sum : -sum;
+      var absv = value > 0 ? value : -value;
+      if (absSum >= absv)
+        correction += (sum - t) + value;
+      else
+        correction += (value - t) + sum;
+      sum = t;
+    }
+
+    public double Get() {
+      return sum + correction;
+    }
+
+    public void Mul(double value) {
+      sum *= value;
+      correction *= value;
+    }
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/Splitting/OrderImpurityCalculator.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/Splitting/OrderImpurityCalculator.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/Splitting/OrderImpurityCalculator.cs	(revision 16892)
@@ -0,0 +1,123 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  /// <summary>
+  /// Helper class for incremental split calculation.
+  /// Used while moving a potential splitter along the ordered training instances
+  /// </summary>
+  internal class OrderImpurityCalculator {
+    internal enum IncrementType {
+      Left,
+      Right,
+      None
+    }
+
+    #region Properties
+    private double SqSumLeft { get; set; }
+    private double SqSumRight { get; set; }
+    private double VarLeft { get; set; }
+    private double VarRight { get; set; }
+    private double Order { get; set; }
+    private double VarTotal { get; set; }
+    private int NoInstances { get; set; }
+
+    private double NoLeft { get; set; }
+    private double NoRight { get; set; }
+    private double SumLeft { get; set; }
+    private double SumRight { get; set; }
+    public double Impurity { get; private set; }
+    #endregion
+
+    #region Constructors
+    public OrderImpurityCalculator(int partition, IReadOnlyCollection<double> data, double order) {
+      var values = data;
+      NoInstances = data.Count;
+      VarTotal = values.VariancePop();
+
+      values = data.Take(partition).ToArray();
+      NoLeft = partition;
+      SumLeft = values.Sum();
+      SqSumLeft = values.Sum(x => x * x);
+
+      values = data.Skip(partition).ToArray();
+      NoRight = NoInstances - NoLeft;
+      SumRight = values.Sum();
+      SqSumRight = values.Sum(x => x * x);
+
+      Order = order;
+      Increment(0.0, IncrementType.None);
+    }
+    #endregion
+
+    #region IImpurityCalculator
+    public void Increment(double value, IncrementType type) {
+      double y, yl, yr;
+      var valSq = value * value;
+
+      switch (type) {
+        case IncrementType.Left:
+          NoLeft++;
+          NoRight--;
+          SumLeft += value;
+          SumRight -= value;
+          SqSumLeft += valSq;
+          SqSumRight -= valSq;
+          break;
+        case IncrementType.Right:
+          NoLeft--;
+          NoRight++;
+          SumLeft -= value;
+          SumRight += value;
+          SqSumLeft -= valSq;
+          SqSumRight += valSq;
+          break;
+        case IncrementType.None:
+          break;
+        default:
+          throw new ArgumentOutOfRangeException(type.ToString(), type, null);
+      }
+
+      VarLeft = NoLeft <= 0 ? 0 : Math.Abs(NoLeft * SqSumLeft - SumLeft * SumLeft) / (NoLeft * NoLeft);
+      VarRight = NoRight <= 0 ? 0 : Math.Abs(NoRight * SqSumRight - SumRight * SumRight) / (NoRight * NoRight);
+
+      if (Order <= 0) throw new ArgumentException("Splitter order must be larger than 0");
+      if (Order.IsAlmost(1)) {
+        y = VarTotal;
+        yl = VarLeft;
+        yr = VarRight;
+      }
+      else {
+        y = Math.Pow(VarTotal, 1.0 / Order);
+        yl = Math.Pow(VarLeft, 1.0 / Order);
+        yr = Math.Pow(VarRight, 1.0 / Order);
+      }
+      if (NoLeft <= 0.0 || NoRight <= 0.0) Impurity = double.MinValue; //Splitter = 0;
+      else Impurity = y - (NoLeft * yl + NoRight * yr) / (NoRight + NoLeft);
+    }
+    #endregion
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/Splitting/SplitterBase.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/Splitting/SplitterBase.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/Splitting/SplitterBase.cs	(revision 16892)
@@ -0,0 +1,140 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Threading;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Problems.DataAnalysis;
+using HEAL.Attic;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  [StorableType("22DCCF28-8943-4622-BBD3-B2AB04F28C36")]
+  [Item("SplitterBase", "Abstract base class for splitters")]
+  public abstract class SplitterBase : ParameterizedNamedItem, ISplitter {
+    public const string SplittingStateVariableName = "SplittingState";
+
+    #region Constructors & Cloning
+    [StorableConstructor]
+    protected SplitterBase(StorableConstructorFlag _) { }
+    protected SplitterBase(SplitterBase original, Cloner cloner) : base(original, cloner) { }
+    public SplitterBase() { }
+    #endregion
+
+    #region ISplitType
+    public void Initialize(IScope states) {
+      states.Variables.Add(new Variable(SplittingStateVariableName, new SplittingState()));
+    }
+
+    public void Split(RegressionNodeTreeModel tree, IReadOnlyList<int> trainingRows, IScope stateScope, CancellationToken cancellationToken) {
+      var regressionTreeParams = (RegressionTreeParameters)stateScope.Variables[M5Regression.RegressionTreeParameterVariableName].Value;
+      var splittingState = (SplittingState)stateScope.Variables[SplittingStateVariableName].Value;
+      var variables = regressionTreeParams.AllowedInputVariables.ToArray();
+      var target = regressionTreeParams.TargetVariable;
+
+      if (splittingState.Code <= 0) {
+        splittingState.nodeQueue.Enqueue(tree.Root);
+        splittingState.trainingRowsQueue.Enqueue(trainingRows);
+        splittingState.Code = 1;
+      }
+      while (splittingState.nodeQueue.Count != 0) {
+        var n = splittingState.nodeQueue.Dequeue();
+        var rows = splittingState.trainingRowsQueue.Dequeue();
+
+        string attr;
+        double splitValue;
+        var isLeaf = !DecideSplit(new RegressionProblemData(RegressionTreeUtilities.ReduceDataset(regressionTreeParams.Data, rows, variables, target), variables, target), regressionTreeParams.MinLeafSize, out attr, out splitValue);
+        if (isLeaf) continue;
+
+        IReadOnlyList<int> leftRows, rightRows;
+        RegressionTreeUtilities.SplitRows(rows, regressionTreeParams.Data, attr, splitValue, out leftRows, out rightRows);
+        n.Split(regressionTreeParams, attr, splitValue, rows.Count);
+
+        splittingState.nodeQueue.Enqueue(n.Left);
+        splittingState.nodeQueue.Enqueue(n.Right);
+        splittingState.trainingRowsQueue.Enqueue(leftRows);
+        splittingState.trainingRowsQueue.Enqueue(rightRows);
+        cancellationToken.ThrowIfCancellationRequested();
+      }
+    }
+
+    protected virtual bool DecideSplit(IRegressionProblemData splitData, int minLeafSize, out string splitAttr, out double splitValue) {
+      var bestPos = -1;
+      var bestImpurity = double.MinValue;
+      var bestSplitValue = 0.0;
+      var bestSplitAttr = string.Empty;
+      splitAttr = bestSplitAttr;
+      splitValue = bestSplitValue;
+      if (splitData.Dataset.Rows < minLeafSize) return false;
+
+      // find best attribute for the splitter
+      foreach (var attr in splitData.AllowedInputVariables) {
+        int pos;
+        double impurity, sValue;
+        var sortedData = splitData.Dataset.GetDoubleValues(attr).Zip(splitData.Dataset.GetDoubleValues(splitData.TargetVariable), Tuple.Create).OrderBy(x => x.Item1).ToArray();
+        AttributeSplit(sortedData.Select(x => x.Item1).ToArray(), sortedData.Select(x => x.Item2).ToArray(), minLeafSize, out pos, out impurity, out sValue);
+        if (!(bestImpurity < impurity)) continue;
+        bestImpurity = impurity;
+        bestPos = pos;
+        bestSplitValue = sValue;
+        bestSplitAttr = attr;
+      }
+
+      splitAttr = bestSplitAttr;
+      splitValue = bestSplitValue;
+      //if no suitable split exists => leafNode
+      return bestPos + 1 >= minLeafSize && bestPos <= splitData.Dataset.Rows - minLeafSize;
+    }
+
+    protected abstract void AttributeSplit(IReadOnlyList<double> attValues, IReadOnlyList<double> targetValues, int minLeafSize, out int position, out double maxImpurity, out double splitValue);
+    #endregion
+
+    [StorableType("BC1149FD-370E-4F3A-92F5-6E519736D09A")]
+    public class SplittingState : Item {
+      [Storable]
+      public Queue<RegressionNodeModel> nodeQueue = new Queue<RegressionNodeModel>();
+      [Storable]
+      public Queue<IReadOnlyList<int>> trainingRowsQueue = new Queue<IReadOnlyList<int>>();
+
+      //State.Code values denote the current action (for pausing)
+      //0...nothing has been done;
+      //1...splitting nodes;
+      [Storable]
+      public int Code = 0;
+
+      #region HLConstructors & Cloning
+      [StorableConstructor]
+      protected SplittingState(StorableConstructorFlag _) : base(_) { }
+      protected SplittingState(SplittingState original, Cloner cloner) : base(original, cloner) {
+        nodeQueue = new Queue<RegressionNodeModel>(original.nodeQueue.Select(cloner.Clone));
+        trainingRowsQueue = new Queue<IReadOnlyList<int>>(original.trainingRowsQueue.Select(x => (IReadOnlyList<int>)x.ToArray()));
+        Code = original.Code;
+      }
+      public SplittingState() { }
+      public override IDeepCloneable Clone(Cloner cloner) {
+        return new SplittingState(this, cloner);
+      }
+      #endregion
+    }
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/Splitting/UnivariateOnlineLR.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/Splitting/UnivariateOnlineLR.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/Splitting/UnivariateOnlineLR.cs	(revision 16892)
@@ -0,0 +1,114 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  /// <summary>
+  /// Helper class for incremental split calculation.
+  /// Used while moving a potential splitter along the ordered training instances
+  /// </summary>
+  internal class UnivariateOnlineLR {
+    #region state
+    private readonly NeumaierSum targetMean;
+    private readonly NeumaierSum attributeMean;
+    private readonly NeumaierSum targetVarSum;
+    private readonly NeumaierSum attributeVarSum;
+    private readonly NeumaierSum comoment;
+    private readonly NeumaierSum ssr;
+    private int size;
+    #endregion
+
+    public double Ssr {
+      get { return ssr.Get(); }
+    }
+    public int Size {
+      get { return size; }
+    }
+
+    private double Beta {
+      get { return comoment.Get() / attributeVarSum.Get(); }
+    }
+    private double Alpha {
+      get { return targetMean.Get() - Beta * attributeMean.Get(); }
+    }
+
+    public UnivariateOnlineLR(ICollection<double> attributeValues, ICollection<double> targetValues) {
+      if (attributeValues.Count != targetValues.Count) throw new ArgumentException("Targets and Attributes need to have the same length");
+      size = attributeValues.Count;
+
+      var yMean = targetValues.Average();
+      var xMean = attributeValues.Average();
+      targetMean = new NeumaierSum(yMean);
+      attributeMean = new NeumaierSum(xMean);
+      targetVarSum = new NeumaierSum(targetValues.VariancePop() * size);
+      attributeVarSum = new NeumaierSum(attributeValues.VariancePop() * size);
+      comoment = new NeumaierSum(attributeValues.Zip(targetValues, (x, y) => (x - xMean) * (y - yMean)).Sum());
+
+      var beta = comoment.Get() / attributeVarSum.Get();
+      var alpha = yMean - beta * xMean;
+      ssr = new NeumaierSum(attributeValues.Zip(targetValues, (x, y) => y - alpha - beta * x).Sum(x => x * x));
+    }
+
+    public void Add(double attributeValue, double targetValue) {
+      var predictOld = Predict(attributeValue, targetValue);
+
+      size++;
+      var dx = attributeValue - attributeMean.Get();
+      var dy = targetValue - targetMean.Get();
+      attributeMean.Add(dx / size);
+      targetMean.Add(dy / size);
+      var dx2 = attributeValue - attributeMean.Get();
+      var dy2 = targetValue - targetMean.Get();
+      attributeVarSum.Add(dx * dx2);
+      targetVarSum.Add(dy * dy2);
+      comoment.Add(dx * dy2);
+
+      ssr.Add(predictOld * Predict(attributeValue, targetValue));
+    }
+
+    public void Remove(double attributeValue, double targetValue) {
+      var predictOld = Predict(attributeValue, targetValue);
+
+      var dx2 = attributeValue - attributeMean.Get();
+      var dy2 = targetValue - targetMean.Get();
+      attributeMean.Mul(size / (size - 1.0));
+      targetMean.Mul(size / (size - 1.0));
+      attributeMean.Add(-attributeValue / (size - 1.0));
+      targetMean.Add(-targetValue / (size - 1.0));
+      var dx = attributeValue - attributeMean.Get();
+      var dy = targetValue - targetMean.Get();
+      attributeVarSum.Add(-dx * dx2);
+      targetVarSum.Add(-dy * dy2);
+      comoment.Add(-dx * dy2);
+      size--;
+
+      ssr.Add(-predictOld * Predict(attributeValue, targetValue));
+    }
+
+    private double Predict(double attributeValue, double targetValue) {
+      return targetValue - Alpha - Beta * attributeValue;
+    }
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis/3.4/CrossValidation.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis/3.4/CrossValidation.cs	(revision 16891)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis/3.4/CrossValidation.cs	(revision 16892)
@@ -300,5 +300,5 @@
         if ((ExecutionState != ExecutionState.Prepared) && (ExecutionState != ExecutionState.Paused))
           throw new InvalidOperationException(string.Format("Start not allowed in execution state \"{0}\".", ExecutionState));
-        seed = new FastRandom().NextInt();
+        seed = RandomSeedGenerator.GetSeed();
 
         if (Algorithm == null) return;
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/RegressionTreeModel.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/RegressionTreeModel.cs	(revision 16891)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis/3.4/GradientBoostedTrees/RegressionTreeModel.cs	(revision 16892)
@@ -91,5 +91,5 @@
     #region old storable format
     // remove with HL 3.4
-    [Storable(AllowOneWay = true)]
+    [Storable(OldName = "SerializedTree")]
     // to prevent storing the references to data caches in nodes
     // seemingly, it is bad (performance-wise) to persist tuples (tuples are used as keys in a dictionary)
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis/3.4/NearestNeighbour/NearestNeighbourModel.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis/3.4/NearestNeighbour/NearestNeighbourModel.cs	(revision 16891)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis/3.4/NearestNeighbour/NearestNeighbourModel.cs	(revision 16892)
@@ -294,5 +294,5 @@
         return IsProblemDataCompatible(classificationProblemData, out errorMessage);
 
-      throw new ArgumentException("The problem data is not a regression nor a classification problem data. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
+      throw new ArgumentException("The problem data is not compatible with this nearest neighbour model. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
     }
 
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis/3.4/NeuralNetwork/NeuralNetworkEnsembleModel.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis/3.4/NeuralNetwork/NeuralNetworkEnsembleModel.cs	(revision 16891)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis/3.4/NeuralNetwork/NeuralNetworkEnsembleModel.cs	(revision 16892)
@@ -144,5 +144,5 @@
         return IsProblemDataCompatible(classificationProblemData, out errorMessage);
 
-      throw new ArgumentException("The problem data is not a regression nor a classification problem data. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
+      throw new ArgumentException("The problem data is not compatible with this neural network ensemble. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
     }
 
@@ -153,5 +153,5 @@
       return new NeuralNetworkEnsembleClassificationSolution(this, new ClassificationEnsembleProblemData(problemData));
     }
-   
+
     #region persistence
     [Storable]
@@ -183,5 +183,5 @@
       }
     }
-    [Storable(AllowOneWay = true)]
+    [Storable(OldName = "MultiLayerPerceptronEnsembleDfdnet")]
     private double[] MultiLayerPerceptronEnsembleDfdnet {
       set {
@@ -197,9 +197,9 @@
       }
     }
-    [Storable(AllowOneWay = true)]
+    [Storable(OldName = "MultiLayerPerceptronEnsembleNeurons")]
     private double[] MultiLayerPerceptronEnsembleNeurons {
       set { mlpEnsemble.innerobj.network.neurons = value; }
     }
-    [Storable(AllowOneWay = true)]
+    [Storable(OldName = "MultiLayerPerceptronEnsembleSerializedMlp")]
     private double[] MultiLayerPerceptronEnsembleSerializedMlp {
       set {
@@ -207,5 +207,5 @@
       }
     }
-    [Storable(AllowOneWay = true)]
+    [Storable(OldName = "MultiLayerPerceptronStuctinfo")]
     private int[] MultiLayerPerceptronStuctinfo {
       set {
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis/3.4/NeuralNetwork/NeuralNetworkModel.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis/3.4/NeuralNetwork/NeuralNetworkModel.cs	(revision 16891)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis/3.4/NeuralNetwork/NeuralNetworkModel.cs	(revision 16892)
@@ -147,5 +147,5 @@
         return IsProblemDataCompatible(classificationProblemData, out errorMessage);
 
-      throw new ArgumentException("The problem data is not a regression nor a classification problem data. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
+      throw new ArgumentException("The problem data is not compatible with this neural network. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
     }
 
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis/3.4/RandomForest/RandomForestModel.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis/3.4/RandomForest/RandomForestModel.cs	(revision 16891)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis/3.4/RandomForest/RandomForestModel.cs	(revision 16892)
@@ -300,5 +300,5 @@
         return IsProblemDataCompatible(classificationProblemData, out errorMessage);
 
-      throw new ArgumentException("The problem data is not a regression nor a classification problem data. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
+      throw new ArgumentException("The problem data is not compatible with this random forest. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
     }
 
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis/3.4/SupportVectorMachine/SupportVectorMachineModel.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis/3.4/SupportVectorMachine/SupportVectorMachineModel.cs	(revision 16891)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis/3.4/SupportVectorMachine/SupportVectorMachineModel.cs	(revision 16892)
@@ -143,5 +143,5 @@
         return IsProblemDataCompatible(classificationProblemData, out errorMessage);
 
-      throw new ArgumentException("The problem data is not a regression nor a classification problem data. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
+      throw new ArgumentException("The problem data is not compatible with this SVM. Instead a " + problemData.GetType().GetPrettyName() + " was provided.", "problemData");
     }
 
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/IslandGeneticAlgorithm.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/IslandGeneticAlgorithm.cs	(revision 16891)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/IslandGeneticAlgorithm.cs	(revision 16892)
@@ -22,4 +22,5 @@
 using System;
 using System.Linq;
+using HEAL.Attic;
 using HeuristicLab.Analysis;
 using HeuristicLab.Common;
@@ -30,5 +31,4 @@
 using HeuristicLab.Optimization.Operators;
 using HeuristicLab.Parameters;
-using HEAL.Attic;
 using HeuristicLab.PluginInfrastructure;
 using HeuristicLab.Random;
@@ -372,6 +372,6 @@
     protected override void OnProblemChanged() {
       ParameterizeStochasticOperator(Problem.SolutionCreator);
+      foreach (IOperator op in Problem.Operators.OfType<IOperator>()) ParameterizeStochasticOperator(op);
       ParameterizeStochasticOperatorForIsland(Problem.Evaluator);
-      foreach (IOperator op in Problem.Operators.OfType<IOperator>()) ParameterizeStochasticOperator(op);
       ParameterizeSolutionsCreator();
       ParameterizeMainLoop();
@@ -402,4 +402,5 @@
     protected override void Problem_OperatorsChanged(object sender, EventArgs e) {
       foreach (IOperator op in Problem.Operators.OfType<IOperator>()) ParameterizeStochasticOperator(op);
+      ParameterizeStochasticOperatorForIsland(Problem.Evaluator);
       ParameterizeIterationBasedOperators();
       UpdateCrossovers();
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/OffspringSelectionGeneticAlgorithmMainOperator.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/OffspringSelectionGeneticAlgorithmMainOperator.cs	(revision 16891)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/OffspringSelectionGeneticAlgorithmMainOperator.cs	(revision 16892)
@@ -20,4 +20,5 @@
 #endregion
 
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -26,5 +27,4 @@
 using HeuristicLab.Optimization.Operators;
 using HeuristicLab.Parameters;
-using HEAL.Attic;
 using HeuristicLab.Selection;
 
@@ -218,8 +218,8 @@
 
       variableCreator1.Name = "MutatedOffspring = true";
-      variableCreator1.CollectedValues.Add(new ValueParameter<BoolValue>("MutatedOffspring", null, new BoolValue(true), false));
+      variableCreator1.CollectedValues.Add(new ValueParameter<BoolValue>("MutatedOffspring", null, new BoolValue(true)) { GetsCollected = false });
 
       variableCreator2.Name = "MutatedOffspring = false";
-      variableCreator2.CollectedValues.Add(new ValueParameter<BoolValue>("MutatedOffspring", null, new BoolValue(false), false));
+      variableCreator2.CollectedValues.Add(new ValueParameter<BoolValue>("MutatedOffspring", null, new BoolValue(false)) { GetsCollected = false });
 
       conditionalSelector.ConditionParameter.ActualName = "MutatedOffspring";
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Analysis/3.3/DataVisualization/DataRowVisualProperties.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Analysis/3.3/DataVisualization/DataRowVisualProperties.cs	(revision 16891)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Analysis/3.3/DataVisualization/DataRowVisualProperties.cs	(revision 16892)
@@ -227,9 +227,9 @@
     internal DataRowHistogramAggregation? Aggregation { get; private set; }
 
-    [Storable(Name = "Bins", AllowOneWay = true)]
+    [Storable(OldName = "Bins")]
     private int StorableBins { set { Bins = value; } }
-    [Storable(Name = "ExactBins", AllowOneWay = true)]
+    [Storable(OldName = "ExactBins")]
     private bool StorableExactBins { set { ExactBins = value; } }
-    [Storable(Name = "Aggregation", AllowOneWay = true)]
+    [Storable(OldName = "Aggregation")]
     private DataRowHistogramAggregation StorableAggregation { set { Aggregation = value; } }
     #endregion
